=== debian/changelog ===
arrayfire (3.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop fix-unneeded-opengl-dep.patch, applied upstream.
  * d/rules: install upstream changelog. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 07 Jul 2015 12:05:32 +0100

arrayfire (3.0.1-1) unstable; urgency=low

  * Initial release (Closes: #785569)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 18 May 2015 10:41:05 +0100
