=== debian/control ===
Source: arrayfire
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               doxygen,
               libboost-dev,
               libfftw3-dev,
               libfreeimage-dev,
               liblapacke-dev,
               libopenblas-dev | libatlas-base-dev | libblas-dev,
               pkg-config
Standards-Version: 3.9.6
Homepage: http://arrayfire.com/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/arrayfire.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/arrayfire.git

Package: libarrayfire-cpu-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libarrayfire-cpu3 (= ${binary:Version})
Suggests: libarrayfire-doc
Description: High performance library for parallel computing (Development)
 ArrayFire is a high performance software library for parallel computing
 with an easy-to-use API. Its array based function set makes parallel
 programming simple.
 .
 ArrayFire's multiple backends (CUDA, OpenCL and native CPU) make it
 platform independent and highly portable.
 .
 A few lines of code in ArrayFire can replace dozens of lines of parallel
 computing code, saving you valuable time and lowering development costs.
 .
 This package provides the ArrayFire development files for the CPU backend.

Package: libarrayfire-cpu3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: High performance library for parallel computing (Library)
 ArrayFire is a high performance software library for parallel computing
 with an easy-to-use API. Its array based function set makes parallel
 programming simple.
 .
 ArrayFire's multiple backends (CUDA, OpenCL and native CPU) make it
 platform independent and highly portable.
 .
 A few lines of code in ArrayFire can replace dozens of lines of parallel
 computing code, saving you valuable time and lowering development costs.
 .
 This package provides the ArrayFire library compiled with CPU backend.

Package: libarrayfire-cpu3-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libarrayfire-cpu3 (= ${binary:Version})
Description: High performance library for parallel computing (Debug)
 ArrayFire is a high performance software library for parallel computing
 with an easy-to-use API. Its array based function set makes parallel
 programming simple.
 .
 ArrayFire's multiple backends (CUDA, OpenCL and native CPU) make it
 platform independent and highly portable.
 .
 A few lines of code in ArrayFire can replace dozens of lines of parallel
 computing code, saving you valuable time and lowering development costs.
 .
 This package provides the ArrayFire library debugging symbols for the CPU 
 backend.

Package: libarrayfire-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Description: High performance library for parallel computing (Documentation)
 ArrayFire is a high performance software library for parallel computing
 with an easy-to-use API. Its array based function set makes parallel
 programming simple.
 .
 ArrayFire's multiple backends (CUDA, OpenCL and native CPU) make it
 platform independent and highly portable.
 .
 A few lines of code in ArrayFire can replace dozens of lines of parallel
 computing code, saving you valuable time and lowering development costs.
 .
 This package provides the ArrayFire documentation.
