=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#DH_VERBOSE = 1

%:
	dh $@ --buildsystem=cmake \
		--parallel \
		--dbg-package=libarrayfire-cpu3-dbg

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_TEST=OFF \
	-DBUILD_EXAMPLES=OFF \
	-DBUILD_GTEST=OFF \
	-DBUILD_CPU=ON \
	-DBUILD_CUDA=OFF \
	-DBUILD_OPENCL=OFF \
	-DBUILD_DOCS=ON \
	-DWITH_COVERAGE=OFF \
	-DBUILD_GRAPHICS=OFF \
	-DAF_INSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DAF_INSTALL_CMAKE_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/ArrayFire

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -f include/af/version.h

override_dh_installchangelogs:
	dh_installchangelogs docs/pages/release_notes.md
